import formUserGlobal from "../../assets/js/global/formUserGlobal";
import formEvent from "./formEvent";
import apiForm from "sasp-form-render/src/assets/js/api/apiForm";
export default {

    buttonRecord: [],
    number:0,

    /**
     * 按键记录赋值
     * buttonName 按键名称
     * rowDataId 数据行ID
     * dataId 数据ID 唯一标识
     * userId 用户ID
     * UserName 用户名
     */
    buttonPush(buttonName, rowDataId, dataId, userId, UserName) {
        //判断是否要开启定时任务
        if (this.number == 0) {
            this.scheduledTasks()
            this.number++;
        }
        // 判断是行内按键还是顶部按键
        let buttonRe = {};
        if (rowDataId) {
            buttonRe.rowDataId = rowDataId;
        }
        buttonRe.buttonName = buttonName;
        buttonRe.formId = dataId;
        buttonRe.clickTime = this.viewDateFormat(new Date(), 'yyyy-MM-dd HH:mm:ss');
        buttonRe.dataFrom = "external";
        //buttonRe.listViewId = this.listViewId;
        if (userId) {
            buttonRe.clickUserId = userId;
            buttonRe.clickUserName = UserName;
        } else {
            buttonRe.clickUserId = formUserGlobal.getLoginUser().id;
            buttonRe.clickUserName = formUserGlobal.getLoginUser().userName;
        }
        this.buttonRecord.push(buttonRe);
    },


    scheduledTasks() {
        //定时任务5分钟请求一次记录按键[]
        setInterval(() => {
            if (this.buttonRecord.length>0){
                this.querzRequest();
            }
        }, 300000);
    },
    /**
     * 请求后台记录数据
     */
    querzRequest() {
        if (this.buttonRecord.length > 0) {
            let dataJson = JSON.stringify(this.buttonRecord);
            console.log(dataJson);
            formEvent.axios.post(apiForm.apis.plFormButtonRecord.batchOperate, {"dataJson": dataJson}).then(res => {
                if (res && res.data && !res.data.operateSuccess) {
                    this.$message.error("保存失败");
                } else {
                    this.buttonRecord = [];
                }
            })
        }
    },

    /**
     * 时间格式化方法（查看表单视图时用到）
     * @param d
     * @param fmt
     * @return {string|void}
     */
    viewDateFormat(d, fmt) {
        if (d) {
            let date = new Date(d);
            let o = {
                "M+": date.getMonth() + 1,                 //月份
                "d+": date.getDate(),                    //日
                "H+": date.getHours(),                   //小时
                "m+": date.getMinutes(),                 //分
                "s+": date.getSeconds(),                 //秒
                "q+": Math.floor((date.getMonth() + 3) / 3), //季度
                "S": date.getMilliseconds()             //毫秒
            };
            if (/(y+)/.test(fmt)) {
                fmt = fmt.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));
            }
            for (let k in o) {
                if (new RegExp("(" + k + ")").test(fmt)) {
                    fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
                }
            }
        } else {
            fmt = '';
        }
        return fmt;
    },
}